Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingPlans/PackingPlan.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingPlans/PackingPlan.cs	(revision 9595)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingPlans/PackingPlan.cs	(revision 9596)
@@ -35,9 +35,12 @@
 using HeuristicLab.Problems.BinPacking.Dimensions;
 using HeuristicLab.Problems.BinPacking.PackingBin;
+using HeuristicLab.Encodings.PackingEncoding.MultiComponentVector;
+using HeuristicLab.Encodings.PackingEncoding.GroupingVector;
+using HeuristicLab.Encodings.PackingEncoding.PackingSequence;
 
 namespace HeuristicLab.Encodings.PackingEncoding.PackingPlan {
   [Item("PackingPlan", "Represents a concrete solution for a bin-packing problem.")]
   [StorableClass]
-  public class PackingPlan<D, B, I> : ParameterizedNamedItem, IPackingPlan
+  public abstract class PackingPlan<D, B, I> : ParameterizedNamedItem, IPackingPlan
     where D : class, IPackingDimensions
     where B : PackingShape<D>, IPackingBin
@@ -52,4 +55,11 @@
       }
     }
+    [Storable]
+    protected bool StackingConstraints { get; set; }
+    [Storable]
+    protected bool UseExtremePoints { get; set; }
+
+    [Storable]
+    public B BinMeasures { get; private set; }
 
     [Storable]
@@ -71,11 +81,10 @@
     #endregion
 
-    public PackingPlan(B binMeasures)
-      : this(){
-      //this.BinPackings.Add(new BinPacking<D,B,I> ());
-    }
-    public PackingPlan()
-      : base() {
-      this.BinPackings = new ObservableList<BinPacking<D, B,I>>();
+    public PackingPlan(B binMeasures, bool useExtremePoints, bool stackingConstraints)
+      : base(){
+        BinMeasures = (B)binMeasures.Clone();
+        StackingConstraints = stackingConstraints;
+        UseExtremePoints = useExtremePoints;
+        BinPackings = new ObservableList<BinPacking<D, B, I>>();
     }
 
@@ -86,8 +95,104 @@
         this.BinPackings = new ObservableList<BinPacking<D, B, I>>(original.BinPackings);
     }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new PackingPlan<D,B,I>(this, cloner);
-    }
-         
+    
+
+    public abstract BinPacking<D, B, I> NewBinPacking();
+    public void UpdateBinPackings() {
+      BinPackings.RemoveAll(x => x.ItemPositions.Count == 0);
+      BinPackings = new ObservableList<BinPacking<D, B, I>>(BinPackings.OrderByDescending (bp => bp.PackingDensity));
+    }
+
+    public void Pack(MultiComponentVectorEncoding solution, ItemList<I> itemMeasures) {
+      var sequenceMatrix = solution.GenerateSequenceMatrix();
+      Dictionary<int, bool> rotated = solution.GenerateRotationArray();
+
+      //Fill bins according to grouping vector
+      List<int> remainingIDs = new List<int>();
+      foreach (var sequence in sequenceMatrix) {
+        remainingIDs = remainingIDs.Concat(sequence).ToList();
+        var bp = NewBinPacking();
+        if (!UseExtremePoints)
+          bp.SlidingBasedPacking(ref remainingIDs, itemMeasures, rotated);
+        else
+          bp.ExtremePointBasedPacking(ref remainingIDs, itemMeasures, StackingConstraints, rotated);
+        BinPackings.Add(bp);
+      }
+      UpdateBinPackings();
+
+      //Try to put remaining items in existing bins
+      var temp = new List<int>(remainingIDs);
+      foreach (int id in temp) {
+        foreach (var bp in BinPackings) {
+          var position = UseExtremePoints ? bp.FindExtremePointForItem(itemMeasures[id], rotated[id], StackingConstraints) : bp.FindPositionBySliding(itemMeasures[id], rotated[id]);
+          if (position != null) {
+            bp.PackItem(id, itemMeasures[id], position);
+            remainingIDs.Remove(id);
+          }
+        }
+      }
+
+      //Put still remaining items in new bins
+      while (remainingIDs.Count > 0) {
+        var bp = NewBinPacking();
+        if (!UseExtremePoints)
+          bp.SlidingBasedPacking(ref remainingIDs, itemMeasures, rotated);
+        else
+          bp.ExtremePointBasedPacking(ref remainingIDs, itemMeasures, StackingConstraints, rotated);
+        BinPackings.Add(bp);
+      }
+      UpdateBinPackings();
+    }
+    public void Pack(GroupingVectorEncoding solution, ItemList<I> itemMeasures) {
+      var sequenceMatrix = solution.GenerateSequenceMatrix();
+
+      //Fill bins according to grouping vector
+      List<int> remainingIDs = new List<int>();
+      foreach (var sequence in sequenceMatrix) {
+        remainingIDs = remainingIDs.Concat(sequence).ToList();
+        var bp = NewBinPacking();
+        if (!UseExtremePoints)
+          bp.SlidingBasedPacking(ref remainingIDs, itemMeasures);
+        else
+          bp.ExtremePointBasedPacking(ref remainingIDs, itemMeasures, StackingConstraints);
+        BinPackings.Add(bp);
+      }
+      UpdateBinPackings();
+
+      //Try to put remaining items in existing bins
+      var temp = new List<int>(remainingIDs);
+      foreach (int id in temp) {
+        foreach (var bp in BinPackings) {  
+          var position = UseExtremePoints ? bp.FindExtremePointForItem (itemMeasures[id], false, StackingConstraints) : bp.FindPositionBySliding(itemMeasures[id], false);
+          if (position != null) {
+            bp.PackItem(id, itemMeasures[id], position);
+            remainingIDs.Remove(id);
+          }
+        }
+      }
+
+      //Put still remaining items in new bins
+      while (remainingIDs.Count > 0) {
+        var bp = NewBinPacking();
+        if (!UseExtremePoints)
+          bp.SlidingBasedPacking(ref remainingIDs, itemMeasures);
+        else
+          bp.ExtremePointBasedPacking(ref remainingIDs, itemMeasures, StackingConstraints);
+        BinPackings.Add(bp);
+      }
+      UpdateBinPackings();
+    }
+    public void Pack(PackingSequenceEncoding solution, ItemList<I> itemMeasures) {
+      List<int> remainingIDs = new List<int>(solution.PackingSequence);
+      while (remainingIDs.Count > 0) {
+        var bp = NewBinPacking();
+        if (!UseExtremePoints)
+          bp.SlidingBasedPacking(ref remainingIDs, itemMeasures);
+        else
+          bp.ExtremePointBasedPacking(ref remainingIDs, itemMeasures, StackingConstraints);
+        BinPackings.Add(bp);
+      }
+      UpdateBinPackings();
+    }
+
 
     #region Events
@@ -126,83 +231,22 @@
   }
 
-  [Item("BinPacking", "Represents a single-bin packing for a bin-packing problem.")]
+
+
+
+  [Item("PackingPlan2D", "Represents a concrete solution for a 2D bin-packing problem.")]
   [StorableClass]
-  public abstract class BinPacking<D,B,I>  : Item
-    where D : class, IPackingDimensions
-    where B : PackingShape<D>, IPackingBin
-    where I : PackingShape<D>, IPackingItem {
-  
-    [Storable]
-    public ObservableDictionary<int, D> ItemPositions { get; private set; }
-
-    [Storable]
-    public B BinMeasures { get; private set; }
-
-    [Storable]
-    public ObservableDictionary<int, I> ItemMeasures { get; private set; }
-
-    [Storable]
-    public HashSet<D> ExtremePoints { get; protected set; }
-
-    [Storable]
-    public OccupiedPoints<D, I> OccupiedPoints { get; protected set; }
-
-    public BinPacking(B binMeasures) : base() {   
-      ItemPositions = new ObservableDictionary<int, D>();
-      ItemMeasures = new ObservableDictionary<int, I>();
-      BinMeasures = (B)binMeasures.Clone();
-      ExtremePoints = new HashSet<D>();
-      ExtremePoints.Add(binMeasures.Origin);
-    }
-
+  public class PackingPlan2D : PackingPlan<TwoDimensionalPacking, RectangularPackingBin, RectangularPackingItem> {
+    public PackingPlan2D(RectangularPackingBin binMeasures) : this(binMeasures, false, false) { }
+    public PackingPlan2D(RectangularPackingBin binMeasures, bool useExtremePoints, bool stackingConstraints) : base(binMeasures, useExtremePoints, stackingConstraints) { } 
     [StorableConstructor]
-    protected BinPacking(bool deserializing) : base(deserializing) { }
-    protected BinPacking(BinPacking<D,B,I> original, Cloner cloner)
+    protected PackingPlan2D(bool deserializing) : base(deserializing) { }
+    protected PackingPlan2D(PackingPlan2D original, Cloner cloner)
       : base(original, cloner) {
-      this.ItemPositions = new ObservableDictionary<int, D>(original.ItemPositions);
-      this.ItemMeasures = new ObservableDictionary<int, I>(original.ItemMeasures);
-        this.BinMeasures = (B)original.BinMeasures.Clone(cloner);
-    }
-   
-
-    protected abstract void GenerateNewExtremePointsForNewItem(I measures, D position);
-    public abstract D FindExtremePointForItem(I measures, bool rotated, bool stackingConstraint);
-    public abstract D FindPositionBySliding(I measures, bool rotated);
-    public void PackItem(int itemID, I measures, D position) {
-      ItemMeasures[itemID] = measures;
-      ItemPositions[itemID] = position;
-      ExtremePoints.Remove(position);
-      GenerateNewExtremePointsForNewItem(measures, position);
-      OccupiedPoints.OccupyPoints(measures, position, itemID);
-    }
-
-
-    public double PackingDensity { 
-      get {
-        double result = 0;
-        foreach (var entry in ItemMeasures)
-          result += entry.Value.MultipliedMeasures;
-        result /= BinMeasures.MultipliedMeasures;
-        return result;
-      }
-    }
-
-    public bool IsPositionFeasible1(I currentItem, D currentPosition) {
-      //In this case feasability is defined as following: 1. the item fits into the bin-borders; 2. the item does not collide with another already packed item
-      if (!BinMeasures.Encloses(currentPosition, currentItem))
-        return false;
-
-      foreach (var ipEntry in ItemPositions) {
-        if (ItemMeasures[ipEntry.Key].Overlaps(ipEntry.Value, currentPosition, currentItem))
-          return false;
-      }
-
-      return true;
-    }
-    public bool IsPositionFeasible(I currentItem, D position) {
-      if (!BinMeasures.Encloses(position, currentItem))
-        return false;
-
-      return OccupiedPoints.IsPositionFeasible (currentItem, position);
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PackingPlan2D(this, cloner);
+    }
+    public override BinPacking<TwoDimensionalPacking, RectangularPackingBin, RectangularPackingItem> NewBinPacking() {
+      return new BinPacking2D(BinMeasures);
     }
   }
@@ -212,246 +256,21 @@
 
 
-  [Item("BinPacking2D", "Represents a single-bin packing for a 2D bin-packing problem.")]
+  [Item("PackingPlan3D", "Represents a concrete solution for a 3D bin-packing problem.")]
   [StorableClass]
-  public class BinPacking2D : BinPacking<TwoDimensionalPacking, RectangularPackingBin, RectangularPackingItem> {
-
-    public BinPacking2D(RectangularPackingBin binMeasures) : base(binMeasures) {
-      OccupiedPoints = new OccupiedPoints2D(binMeasures);
-    }
+  public class PackingPlan3D : PackingPlan<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem> {
+    public PackingPlan3D(CuboidPackingBin binMeasures) : this(binMeasures, false, false) { }
+    public PackingPlan3D(CuboidPackingBin binMeasures, bool useExtremePoints, bool stackingConstraints) : base(binMeasures, useExtremePoints, stackingConstraints) { } 
     [StorableConstructor]
-    protected BinPacking2D(bool deserializing) : base(deserializing) { }
-    protected BinPacking2D(BinPacking2D original, Cloner cloner)
+    protected PackingPlan3D(bool deserializing) : base(deserializing) { }
+    protected PackingPlan3D(PackingPlan3D original, Cloner cloner)
       : base(original, cloner) {
     }
     public override IDeepCloneable Clone(Cloner cloner) {
-      return new BinPacking2D(this, cloner);
-    }
-                      
-    protected override void GenerateNewExtremePointsForNewItem(RectangularPackingItem newItem, TwoDimensionalPacking position) {
-
-      int newWidth = position.Rotated ? newItem.Height : newItem.Width;
-      int newHeight = position.Rotated ? newItem.Width : newItem.Height;
-
-      //Find ExtremePoints beginning from sourcepointX
-      var sourcePointX = new TwoDimensionalPacking(0, position.X + newWidth, position.Y);
-      if (sourcePointX.X < BinMeasures.Width && sourcePointX.Y < BinMeasures.Height) {
-        //Traversing down the y-axis        
-        while (sourcePointX.Y > 0 && !OccupiedPoints.IsPointOccupied(new TwoDimensionalPacking(0, sourcePointX.X, sourcePointX.Y - 1))) {
-          sourcePointX.Y--;
-        }
-        ExtremePoints.Add(new TwoDimensionalPacking(0, sourcePointX.X, sourcePointX.Y));
-      }
-
-
-
-
-      //Find ExtremePoints beginning from sourcepointY
-      var sourcePointY = new TwoDimensionalPacking(0, position.X, position.Y + newItem.Height);
-      if (sourcePointY.X < BinMeasures.Width && sourcePointY.Y < BinMeasures.Height) {
-        //Traversing down the x-axis  
-        while (sourcePointY.X > 0 && !OccupiedPoints.IsPointOccupied(new TwoDimensionalPacking (0,sourcePointY.X - 1, sourcePointY.Y))) {
-          sourcePointY.X--;
-        }
-        ExtremePoints.Add(new TwoDimensionalPacking(0, sourcePointY.X, sourcePointY.Y));
-      }
-
-      ExtremePoints = new HashSet<TwoDimensionalPacking>(ExtremePoints.
-        OrderBy(ep => ep.AssignedBin).
-        ThenBy(ep => ep.X).
-        ThenBy(ep => ep.Y).
-        ThenBy(ep => OccupiedPoints.ShortestPossibleSideFromEP(ep)));
-    }
-
-    public override TwoDimensionalPacking FindExtremePointForItem(RectangularPackingItem measures, bool rotated, bool stackingConstraint) {
-      RectangularPackingItem item = new RectangularPackingItem(
-        rotated ? measures.Height : measures.Width,
-        rotated ? measures.Width : measures.Height,
-        measures.TargetBin);
-
-      int epIndex = 0;
-      while (epIndex < ExtremePoints.Count && (!IsPositionFeasible(item, ExtremePoints.ElementAt(epIndex)))) { epIndex++; }
-
-      if (epIndex < ExtremePoints.Count) {
-        var result = ExtremePoints.ElementAt(epIndex);
-        result.Rotated = rotated;
-        return result;
-      }
-      return null;
-    }
-    public override TwoDimensionalPacking FindPositionBySliding(RectangularPackingItem measures, bool rotated) {
-      TwoDimensionalPacking currentPosition = new TwoDimensionalPacking(0,
-        BinMeasures.Width - (rotated ? measures.Height : measures.Width),
-        BinMeasures.Height - (rotated ? measures.Width : measures.Height), rotated);
-      //Slide the item as far as possible to the left
-      while (IsPositionFeasible(measures, MoveLeft(currentPosition))
-        || IsPositionFeasible(measures, MoveDown(currentPosition))) {
-        //Slide the item as far as possible to the bottom
-        while (IsPositionFeasible(measures, MoveDown(currentPosition))) {
-          currentPosition = MoveDown(currentPosition);
-        }
-        if (IsPositionFeasible(measures, MoveLeft(currentPosition)))
-          currentPosition = MoveLeft(currentPosition);
-      }
-
-      return IsPositionFeasible(measures, currentPosition) ? currentPosition : null;
-    }
-    private static TwoDimensionalPacking MoveLeft(TwoDimensionalPacking original) {
-      return new TwoDimensionalPacking(original.AssignedBin, original.X - 1, original.Y, original.Rotated);
-    }
-    private static TwoDimensionalPacking MoveDown(TwoDimensionalPacking original) {
-      return new TwoDimensionalPacking(original.AssignedBin, original.X, original.Y - 1, original.Rotated);
+      return new PackingPlan3D(this, cloner);
+    }
+    public override BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem> NewBinPacking() {
+      return new BinPacking3D(BinMeasures);
     }
   }
 
-
-
-  [Item("BinPacking3D", "Represents a single-bin packing for a 3D bin-packing problem.")]
-  [StorableClass]
-  public class BinPacking3D : BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem> {
-
-    
-    public BinPacking3D(CuboidPackingBin binMeasures) : base(binMeasures) {
-      OccupiedPoints = new OccupiedPoints3D(binMeasures);
-    }
-    [StorableConstructor]
-    protected BinPacking3D(bool deserializing) : base(deserializing) { }
-    protected BinPacking3D(BinPacking3D original, Cloner cloner)
-      : base(original, cloner) {
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new BinPacking3D(this, cloner);
-    }
-                                       
-    protected override void GenerateNewExtremePointsForNewItem(CuboidPackingItem newItem, ThreeDimensionalPacking position) {
-      int newWidth = position.Rotated ? newItem.Depth : newItem.Width;
-      int newDepth = position.Rotated ? newItem.Width : newItem.Depth;
-
-      //Find ExtremePoints beginning from sourcepointX
-      var sourcePointX = new ThreeDimensionalPacking(0, position.X + newWidth, position.Y, position.Z);
-      if (sourcePointX.X < BinMeasures.Width && sourcePointX.Y < BinMeasures.Height && sourcePointX.Z < BinMeasures.Depth) {
-        //Traversing down the y-axis                                                                            
-        int currentYValue = sourcePointX.Y;
-        while (currentYValue > 0 && !OccupiedPoints.IsPointOccupied(new ThreeDimensionalPacking (0, sourcePointX.X, currentYValue, sourcePointX.Z))) {
-          currentYValue--;
-        }
-        ExtremePoints.Add(new ThreeDimensionalPacking(0, sourcePointX.X, currentYValue, sourcePointX.Z));
-
-        //Traversing down the z-axis
-        int currentZValue = sourcePointX.Z;
-        while (currentZValue > 0 && !OccupiedPoints.IsPointOccupied(new ThreeDimensionalPacking (0, sourcePointX.X, sourcePointX.Y, currentZValue - 1))) {
-          currentZValue--;
-        }
-        ExtremePoints.Add(new ThreeDimensionalPacking(0, sourcePointX.X, sourcePointX.Y, currentZValue));
-      }
-
-
-
-
-      //Find ExtremePoints beginning from sourcepointY
-      var sourcePointY = new ThreeDimensionalPacking(0, position.X, position.Y + newItem.Height, position.Z);
-      if (sourcePointY.X < BinMeasures.Width && sourcePointY.Y < BinMeasures.Height && sourcePointY.Z < BinMeasures.Depth) {
-        //Traversing down the x-axis  
-        int currentXValue = sourcePointY.X;
-        while (currentXValue > 0 && !OccupiedPoints.IsPointOccupied(new ThreeDimensionalPacking (0, currentXValue - 1, sourcePointY.Y, sourcePointY.Z))) {
-          currentXValue--;
-        }
-        ExtremePoints.Add(new ThreeDimensionalPacking(0, currentXValue, sourcePointY.Y, sourcePointY.Z));
-
-        //Traversing down the z-axis
-        int currentZValue = sourcePointY.Z;
-        while (currentZValue > 0 && !OccupiedPoints.IsPointOccupied(new ThreeDimensionalPacking (0, sourcePointY.X, sourcePointY.Y, currentZValue - 1))) {
-          currentZValue--;
-        }
-        ExtremePoints.Add(new ThreeDimensionalPacking(0, sourcePointY.X, sourcePointY.Y, currentZValue));
-      }
-
-
-
-
-
-      //Find ExtremePoints beginning from sourcepointZ
-      var sourcePointZ = new ThreeDimensionalPacking(0, position.X, position.Y, position.Z + newDepth);
-      if (sourcePointZ.X < BinMeasures.Width && sourcePointZ.Y < BinMeasures.Height && sourcePointZ.Z < BinMeasures.Depth) {
-        //Traversing down the x-axis  
-        int currentXValue = sourcePointZ.X;
-        while (currentXValue > 0 && !OccupiedPoints.IsPointOccupied(new ThreeDimensionalPacking (0, currentXValue - 1, sourcePointZ.Y, sourcePointZ.Z))) {
-          currentXValue--;
-        }
-        ExtremePoints.Add(new ThreeDimensionalPacking(0, currentXValue, sourcePointZ.Y, sourcePointZ.Z));
-
-        //Traversing down the y-axis                                                                            
-        int currentYValue = sourcePointZ.Y;
-        while (currentYValue > 0 && !OccupiedPoints.IsPointOccupied(new ThreeDimensionalPacking (0, sourcePointZ.X, currentYValue, sourcePointZ.Z))) {
-          currentYValue--;
-        }
-        ExtremePoints.Add(new ThreeDimensionalPacking(0, sourcePointZ.X, currentYValue, sourcePointZ.Z));
-      }
-
-      ExtremePoints = new HashSet<ThreeDimensionalPacking>(ExtremePoints.
-        OrderBy(ep => ep.AssignedBin).
-        ThenBy(ep => ep.Z).
-        ThenBy(ep => ep.X).
-        ThenBy(ep => ep.Y).
-        ThenBy(ep => OccupiedPoints.ShortestPossibleSideFromEP(ep)));
-    }
-
-    public override ThreeDimensionalPacking FindExtremePointForItem(CuboidPackingItem measures, bool rotated, bool stackingConstraint) {
-
-      CuboidPackingItem item = new CuboidPackingItem(
-        rotated ? measures.Depth : measures.Width,
-        measures.Height,
-        rotated ? measures.Width : measures.Depth,
-        measures.TargetBin);
-
-      int epIndex = 0;
-      while (epIndex < ExtremePoints.Count && (
-        !IsPositionFeasible(item, ExtremePoints.ElementAt(epIndex)) || (stackingConstraint && !OccupiedPoints.IsStaticStable(item, ExtremePoints.ElementAt(epIndex)))
-      )) { epIndex++; }
-
-      if (epIndex < ExtremePoints.Count) {
-        var result = ExtremePoints.ElementAt(epIndex);
-        result.Rotated = rotated;
-        return result;
-      }
-      return null;
-    }
-    public override ThreeDimensionalPacking FindPositionBySliding(CuboidPackingItem measures, bool rotated) {
-      //Starting-position at upper right corner (=left bottom point of item-rectangle is at position item.width,item.height)
-      ThreeDimensionalPacking currentPosition = new ThreeDimensionalPacking(0,
-        BinMeasures.Width - (rotated ? measures.Depth : measures.Width),
-        BinMeasures.Height - measures.Height,
-        BinMeasures.Depth - (rotated ? measures.Width : measures.Depth), rotated);
-      //Slide the item as far as possible to the bottom
-      while (IsPositionFeasible(measures, MoveDown(currentPosition))
-        || IsPositionFeasible(measures, MoveLeft(currentPosition))
-        || IsPositionFeasible(measures, MoveBack(currentPosition))) {
-        //Slide the item as far as possible to the left
-        while (IsPositionFeasible(measures, MoveLeft(currentPosition))
-        || IsPositionFeasible(measures, MoveBack(currentPosition))) {
-          //Slide the item as far as possible to the back
-          while (IsPositionFeasible(measures, MoveBack(currentPosition))) {
-            currentPosition = MoveBack(currentPosition);
-          }
-          if (IsPositionFeasible(measures, MoveLeft(currentPosition)))
-            currentPosition = MoveLeft(currentPosition);
-        }
-        if (IsPositionFeasible(measures, MoveDown(currentPosition)))
-          currentPosition = MoveDown(currentPosition);
-      }
-
-      return IsPositionFeasible(measures, currentPosition) ? currentPosition : null;
-    }
-    private static ThreeDimensionalPacking MoveLeft(ThreeDimensionalPacking original) {
-      return new ThreeDimensionalPacking(original.AssignedBin, original.X - 1, original.Y, original.Z, original.Rotated);
-    }
-    private static ThreeDimensionalPacking MoveDown(ThreeDimensionalPacking original) {
-      return new ThreeDimensionalPacking(original.AssignedBin, original.X, original.Y - 1, original.Z, original.Rotated);
-    }
-    private static ThreeDimensionalPacking MoveBack(ThreeDimensionalPacking original) {
-      return new ThreeDimensionalPacking(original.AssignedBin, original.X, original.Y, original.Z - 1, original.Rotated);
-    }
-  }
-
-
-
 }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/HeuristicLab.Problems.BinPacking-3.3.csproj
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/HeuristicLab.Problems.BinPacking-3.3.csproj	(revision 9595)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/HeuristicLab.Problems.BinPacking-3.3.csproj	(revision 9596)
@@ -166,9 +166,7 @@
     <Compile Include="Analyzers\BinPackingAnalyzer.cs" />
     <Compile Include="Decoders\2D\BL\BottomLeftMultiComponentVectorDecoder.cs" />
-    <Compile Include="Decoders\2D\TwoDimensionalPackingFunctions.cs" />
     <Compile Include="Decoders\2D\EP\ExtremePointGroupingVectorDecoder2D.cs" />
     <Compile Include="Decoders\2D\EP\ExtremePointMultiComponentVectorDecoder2D.cs" />
     <Compile Include="Decoders\2D\EP\ExtremePointPackingSequenceDecoder2D.cs" />
-    <Compile Include="Decoders\3D\ThreeDimensionalPackingFunctions.cs" />
     <Compile Include="Decoders\3D\EP\ExtremePointMultiComponentVectorDecoder3D.cs" />
     <Compile Include="Decoders\3D\EP\ExtremePointGroupingVectorDecoder3D.cs" />
@@ -180,11 +178,5 @@
     <Compile Include="Decoders\2D\BL\BottomLeftPackingSequenceDecoder.cs" />
     <Compile Include="Decoders\3D\EP\ISOContainerMultiComponentVectorDecoder3D.cs" />
-    <Compile Include="Decoders\SequentialPackingFunctions.cs">
-      <SubType>Code</SubType>
-    </Compile>
     <Compile Include="Decoders\PackingSolutionDecoder.cs" />
-    <Compile Include="Dimensions\OccupiedPoints3D.cs" />
-    <Compile Include="Dimensions\OccupiedPoints2D.cs" />
-    <Compile Include="Dimensions\OccupiedPoints.cs" />
     <Compile Include="Encodings\GroupingVector\GroupingVectorSwap2Manipulator.cs" />
     <Compile Include="Encodings\GroupingVector\GroupingVectorSinglePointCrossover.cs" />
@@ -211,6 +203,6 @@
     <Compile Include="Encodings\GroupingVector\GroupingVectorManipulator.cs" />
     <Compile Include="Encodings\GroupingVector\GroupingVectorRandomCreator.cs" />
+    <Compile Include="Encodings\MultiComponentVector\SequenceBasedMultiComponentVectorCrossover.cs" />
     <Compile Include="Encodings\MultiComponentVector\BinBasedMultiComponentVectorCrossover.cs" />
-    <Compile Include="Encodings\MultiComponentVector\SequenceBasedMultiComponentVectorCrossover.cs" />
     <Compile Include="Encodings\MultiComponentVector\Moves\Multi\Attributes\ChangePositionMoveAttribute.cs" />
     <Compile Include="Encodings\MultiComponentVector\Moves\Triple\Attributes\MCVTripleMoveAttribute.cs" />
@@ -241,4 +233,7 @@
     <Compile Include="Encodings\MultiComponentVector\MultiComponentVectorRandomCreator.cs" />
     <Compile Include="Encodings\MultiComponentVector\ThreeWayMultiComponentVectorManipulator.cs" />
+    <Compile Include="Encodings\PackingPlans\BinPacking2D.cs" />
+    <Compile Include="Encodings\PackingPlans\BinPacking3D.cs" />
+    <Compile Include="Encodings\PackingPlans\BinPacking.cs" />
     <Compile Include="Encodings\PackingPlans\PackingPlan.cs" />
     <Compile Include="Encodings\PackingSequence\Moves\Insertion\ExhaustiveInsertionMoveGenerator.cs" />
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Instances/BPPORLIBParser.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Instances/BPPORLIBParser.cs	(revision 9595)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Instances/BPPORLIBParser.cs	(revision 9596)
@@ -90,5 +90,5 @@
 
       for (int k = 0; k < Items; k++) {
-        if (reader.EndOfStream) throw new InvalidDataException("Unexpected End of Stream.");
+        if (reader.EndOfStream) throw new InvalidDataException("Unexpected End of Stream (at line " + k + ").");
         var valLine = reader.ReadLine();
         while (String.IsNullOrWhiteSpace(valLine)) valLine = reader.ReadLine();
@@ -101,16 +101,21 @@
       }
 
-      int problemClassNr = int.Parse(problemClass[0]);
-      Name = (isThreeDimensional ? "3" : "2") + "dbpp_class_0" + problemClassNr;
-      if (!isThreeDimensional) {
-        if (problemClassNr >= 1 && problemClassNr <= 5)
-          Description = "Proposed by Berkey and Wang.";
-        else if (problemClassNr >= 6 && problemClassNr <= 10)
-          Description = "Proposed by Martello and Vigo.";
+      Int32 problemClassNr = -1;
+      if (int.TryParse(problemClass[0], out problemClassNr)) {
+        Name = (isThreeDimensional ? "3" : "2") + "dbpp_class_0" + problemClassNr;
+        if (!isThreeDimensional) {
+          if (problemClassNr >= 1 && problemClassNr <= 5)
+            Description = "Proposed by Berkey and Wang.";
+          else if (problemClassNr >= 6 && problemClassNr <= 10)
+            Description = "Proposed by Martello and Vigo.";
+        } else {
+          if (problemClassNr >= 1 && problemClassNr <= 5)
+            Description = "Proposed by Martello and Vigo.";
+          else if (problemClassNr >= 6 && problemClassNr <= 9)
+            Description = "Proposed by Berkey and Wang.";
+        }
       } else {
-        if (problemClassNr >= 1 && problemClassNr <= 5)
-          Description = "Proposed by Martello and Vigo.";
-        else if (problemClassNr >= 6 && problemClassNr <= 9)
-          Description = "Proposed by Berkey and Wang.";
+        Name = "Unknown";
+        Description = "<Missing>";
       }
       
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Plugin.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Plugin.cs	(revision 9595)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Plugin.cs	(revision 9596)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Problems.BinPacking plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Problems.BinPacking", "3.3.7.9563")]
+  [Plugin("HeuristicLab.Problems.BinPacking", "3.3.7.9593")]
   [PluginFile("HeuristicLab.Problems.BinPacking-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Common", "3.3")]
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Shapes/CuboidPackingShape.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Shapes/CuboidPackingShape.cs	(revision 9595)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Shapes/CuboidPackingShape.cs	(revision 9596)
@@ -55,5 +55,14 @@
     public override ThreeDimensionalPacking Origin { get { return new ThreeDimensionalPacking(0, 0, 0, 0); } }
     public override int MultipliedMeasures { get { return Width * Height * Depth; } }
-   
+
+    public override bool EnclosesPoint(ThreeDimensionalPacking myPosition, ThreeDimensionalPacking checkedPoint) {
+      var c = new CuboidDiagonal(myPosition, this);
+      return (c.x1 <= checkedPoint.X &&
+                c.x2 >= checkedPoint.X &&
+                c.y1 <= checkedPoint.Y &&
+                c.y2 >= checkedPoint.Y &&
+                c.z1 <= checkedPoint.Z &&
+                c.z2 >= checkedPoint.Z);
+    }
     public override bool Encloses(ThreeDimensionalPacking checkedPosition, PackingShape<ThreeDimensionalPacking> checkedShape) {
       return Encloses(checkedPosition, (CuboidPackingShape) checkedShape);
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Shapes/PackingShape.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Shapes/PackingShape.cs	(revision 9595)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Shapes/PackingShape.cs	(revision 9596)
@@ -39,4 +39,5 @@
     }
 
+    public abstract bool EnclosesPoint(D myPosition, D checkedPoint);
     public abstract bool Encloses(D checkedPosition, PackingShape<D> checkedShape);
     public abstract bool Overlaps(D myPosition, D checkedPosition, PackingShape<D> checkedShape);
